/*****************************/
/*                           */
/*    Zuordnungsgert fr    */
/*       8 Leitungen         */
/*                           */
/*         EMPFNGER         */
/*                           */
/*****************************/

#define F_CPU 8000000UL


#include <avr/io.h>
#include <stdio.h>
#include <util/delay.h>
#include <util/7-Seg.h>
#include <util/ADC.h>
#include <avr/sleep.h>
#include <avr/interrupt.h>


volatile uint16_t Flanke1;
volatile uint16_t Flanke2;
uint16_t Pulsdauer, Volt;
volatile int a, b;

int Batterie (void)
{
	ReadChannel(0);
	while (result < 500)								// 6V Batteriespannung entsprechen einem ADC-Wert von 500
	{
		_delay_ms(250);
		PORTC^= (1<<PC1);								// solange ADC-Wert zu niedrig, LED toggeln...
		_delay_ms(100);
		ReadChannel(0);
	}
	return (0);
}

int LED (uint16_t Pulsdauer)
{
	SEG_PORT |= (1<<CC);
	if (Pulsdauer > 75 && Pulsdauer < 85)
	{
		Zahl (1);
	}
	else if (Pulsdauer > 155 && Pulsdauer < 170)
	{
		Zahl (2);
	}
	else if (Pulsdauer > 235 && Pulsdauer < 250)
	{
		Zahl (3);
	}
	else if (Pulsdauer > 315 && Pulsdauer < 330)
	{
		Zahl (4);
	}
	else if (Pulsdauer > 395 && Pulsdauer < 410)
	{
		Zahl (5);
	}
	else if (Pulsdauer > 475 && Pulsdauer < 490)
	{
		Zahl (6);
	}
	else if (Pulsdauer > 560 && Pulsdauer < 570)
	{
		Zahl (7);
	}
	else if (Pulsdauer > 640 && Pulsdauer < 650)
	{
		Zahl (8);
	}
	SEG_PORT &=~(1<<CC);
	return(0);
}


ISR (TIMER1_CAPT_vect)
{
	if (TCCR1B & (1<<ICES1))					// Test auf steigende Flanke
	{
		Flanke1 = ICR1;							// Input Capture Register = Flanke 1
		TCCR1B &=~(1<<ICES1); 					// ICP1 auf fallende Flanke stellen
		a = 1;
	}
	else
	{
		Flanke2 = ICR1;							// Input Capture Register = Flanke 2
		TCCR1B |= (1<<ICES1); 					// ICP1 auf steigende Flanke stellen
		TCNT1 = 0;
		a = 2;
	}
}

int main (void)
{
	PORTB = 0b00111110;
	DDRB  = 0b00111110;
	PORTC = 0b00000000;
	DDRC  = 0b11111110;
	PORTD = 0b00000000;
	DDRD  = 0b11111111;

	adc_init (0);
	Batterie();

	TIMSK  |= (1<<TICIE1);									// Input Capture enable
 	TCCR1B |= (1<<CS10)|(1<<CS12)|(1<<ICNC1)|(1<<ICES1);	// Timer1 => 1/1024 CPU-Clock, NoiseCanceler an, ICP1 steigende Flanke

	cli();
	sleep_enable();
	set_sleep_mode(SLEEP_MODE_IDLE);
	sei();
	while (1)
	{
		if (a == 0)
		{
			Batterie();
			b++;
			_delay_ms(1);
			if (b == 10000)									// Zeit ohne Messung bis zum Idle - Mode
			{
				sleep_mode();
			}
		}
		else if (a == 2)									// abgeschlossene Messungen verrechnen und auf 7-Segment Anzeige ausgeben...
		{
			Pulsdauer = (Flanke2 - Flanke1);
			a = 0;
			LED (Pulsdauer);
		}
	}
	return (0);
}
