/*****************************/
/*                           */
/*    Zuordnungsgert fr    */
/*       8 Leitungen         */
/*                           */
/*         EMPFNGER         */
/*                           */
/*****************************/

#define F_CPU 8000000UL

#include <avr/io.h>
#include <stdio.h>
//#include <avr/interrupt.h>
#include <util/delay.h>
#include <util/SPI_LCD.h>

//volatile uint8_t overflow = 0;

uint8_t i, mux;
uint16_t result;

void adc_init (uint8_t mux)
{
	ADCSRA = (1<<ADEN)|(1<<ADPS1)|(1<<ADPS0);	//Frequenzvorteiler auf 8 setzen und ADC aktivieren
	ADMUX = mux;								//Kanal whlen
	ADMUX |=(1<<REFS0);							//AVcc als Refenzspannung nutzen
	ADCSRA |=(1<<ADSC);							//empfohlender Dummy-Readout zum Warmlaufen des ADC
	while (ADCSRA &(1<<ADSC))					//auf Abschlu der ADC-Wandlung warten
	{;}
	result=ADC;									//ADCW mu einmal gelesen werden, sonst wird das Ergebnis der nchsten Wandlung nicht bernommen!
}

uint16_t ReadChannel(uint8_t mux)
{
	result=0;
	ADCSRA |=(1<<ADSC);
	while (ADCSRA &(1<<ADSC))
	{;}
	result = ADC;
	return result;
}

int Batterie (void)
{
	adc_init (0);
	ReadChannel(0);										// Batterie schwach / leer???
	if (result < 700)			// Wert noch anpassen!!!
	{
LowBat:
		lcd_Clear();
		lcd_xy(0,0);
		_delay_ms(250);
		lcd_String("Batterie leer");
		lcd_xy(0,1);
		lcd_String("bitte wechseln!");
		_delay_ms(200);
		goto LowBat;
	}
	if (result < 750)			// Wert noch anpassen!!!
	{
		for (i=0; i<100; i++)
		{
			lcd_Clear();
			lcd_xy(0,1);
			_delay_ms(250);
			lcd_String("Batterie schwach");
			_delay_ms(200);
		}
	}
	return (0);
}

int main (void)
{
	PORTB = 0b11111111;
	DDRB  = 0b11111111;
	PORTC = 0b00000000;
	DDRC  = 0b11111110;
	PORTD = 0b00000000;
	DDRD  = 0b00000000;
	init_SPI();
	init_LCD();
//	Batterie();
	_delay_ms(100);
	lcd_String("Leitungszuordner");
	lcd_xy(0,2);
	lcd_Daten(0b00001111);
	lcd_xy(2,2);
	lcd_String("by Axel Lemke");

	for (i=0; i<30;i++)
	{
		_delay_ms(100);
	}

	lcd_Clear();
	_delay_ms(250);
	lcd_kommando (0b00111101);									// Funktionsset: 8Bit; 2 Zeilen, dopelte Hhe; Instruktionstabelle 1
	lcd_kommando (0b00011100);									// BIAS Set
	lcd_kommando (0b00111110);									// Funktionsset: Instruktionstablle 2
	lcd_kommando (0b00011000);									// Position der doppelten Hhe
	lcd_Clear();
	lcd_String("Leitung Nr.:");
	lcd_xy(0,2);
	lcd_Daten(0b00001111);
	lcd_xy(2,2);
	lcd_String("by Axel Lemke");



}
